package com.ehsure.database_plugin;

import android.app.Activity;
import android.content.Intent;
import android.content.IntentFilter;
import android.text.TextUtils;

import androidx.annotation.NonNull;

import org.json.JSONException;
import org.json.JSONObject;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.BasicMessageChannel;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import io.flutter.plugin.common.StringCodec;

/** DatabasePlugin */
public class DatabasePlugin implements FlutterPlugin,  ActivityAware {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private BasicMessageChannel<String> channel;
  private Activity activity;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new BasicMessageChannel<>(flutterPluginBinding.getBinaryMessenger(), "database_plugin", StringCodec.INSTANCE);
    channel.setMessageHandler((message, reply) -> {
      if (TextUtils.isEmpty(message)) {
        reply.reply("db name is empty");
        return;
      }
      Intent intent = new Intent(activity, ReaderActivity.class);
      intent.putExtra("dbName",message);
      activity.startActivity(intent);
//      try {
//        JSONObject jsonObject = new JSONObject(message);
//        action = jsonObject.getString("action");
//        extra = jsonObject.getString("extra");
//        IntentFilter intentFilter = new IntentFilter(action);
//        activity.registerReceiver(scannerReceiver, intentFilter);
//        reply.reply("PDA connection successful");
//      } catch (JSONException e) {
//        reply.reply("ACTION and EXTRA mast be required");
//        e.printStackTrace();
//      }
    });
  }

//  @Override
//  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
//    if (call.method.equals("getPlatformVersion")) {
//      Intent intent = new Intent(activity, ReaderActivity.class);
//      activity.startActivity(intent);
//    } else {
//      result.notImplemented();
//    }
//  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMessageHandler(null);
  }

  @Override
  public void onAttachedToActivity(@NonNull ActivityPluginBinding binding) {
    activity = binding.getActivity();
  }

  @Override
  public void onDetachedFromActivityForConfigChanges() {

  }

  @Override
  public void onReattachedToActivityForConfigChanges(@NonNull ActivityPluginBinding binding) {

  }

  @Override
  public void onDetachedFromActivity() {

  }
}
