package com.ehsure.database_plugin;

import android.app.Activity;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.os.Environment;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;

public class ReaderActivity extends Activity {
    ArrayAdapter<String> adapter;
    Button button;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.reader_page);
        button = (Button)findViewById(R.id.button1);
        //创建MyDatabaseHelper对象
        adapter = new ArrayAdapter<String>(ReaderActivity.this, android.R.layout.simple_list_item_1);
        ListView listView = (ListView)findViewById(R.id.list1);
        listView.setAdapter(adapter);
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                //通过SQLiteDatabase返回的对象对数据库进行操作
                //getWritableDatabase()方法创建或打开一个可读数据库
                SQLiteDatabase db = openDatabase();
                //查询student表中所有数据
                //查询到的数据都将从Cursor对象取出
                Cursor cursor = db.query(false, "Task", null, null, null ,null, null, null, null);
                if (cursor.moveToFirst()){//遍历对象
                    do {
                        //向适配器中添加数据
                        adapter.add(cursor.getString(cursor.getColumnIndex("id")));
                        adapter.add(cursor.getString(cursor.getColumnIndex("message")));
                    }while (cursor.moveToNext());
                }
                cursor.close();
            }
        });
    }

    private SQLiteDatabase openDatabase() {
        String dbFd= "/data"+ Environment.getDataDirectory().getAbsolutePath() + "/" + getPackageName()+"/databases/";
        String dbfile= dbFd+getIntent().getStringExtra("dbName");
        SQLiteDatabase db = SQLiteDatabase.openOrCreateDatabase(dbfile, null);
        return db;
    }
}
